<?php
	include("../../../config.php");
	include("../../../scripts/functions.php");



	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}

	$type = $sourceType;
	$path = $filePath;

	if($displayTempUnits=="C"){
		$thermometerMinimum = $thermometerMinimumC;
		$thermometerMaximum = $thermometerMaximumC;
	}
	if($displayTempUnits=="F"){
		$thermometerMinimum = $thermometerMinimumF;
		$thermometerMaximum = $thermometerMaximumF;
	}

	// use API
	if($type=="api"){
		$apiData = file_get_contents("../../../meteotemplateLive.txt");
		$apiData = json_decode($apiData,true);
		$current['T'] = number_format(convertor($apiData['T'],"C",$displayTempUnits),1,".","");
		$current['D'] = number_format(convertor($apiData['D'],"C",$displayTempUnits),1,".","");
		$current['A'] = number_format(convertor($apiData['A'],"C",$displayTempUnits),1,".","");
	}

	// update from database
	if($type=="db"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,A,D
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
		}
	}

	// update from database from WL
	if($type=="wl"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,A,D
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
		}
	}

	// update from clientraw
	if($type=="wd"){
		// set units for wd
		$dataTempUnits = "C";
		$clientraw = file_get_contents($path);
		$clientrawData = explode(" ",$clientraw);

		$current['T'] = number_format(convertT($clientrawData[4]),1,".","");
		$current['D'] = number_format(convertT($clientrawData[72]),1,".","");
		$apparentT = apparentWD($clientrawData[4],$clientrawData[5],($clientrawData[1]*0.514444));
		$current['A'] = number_format(convertT($apparentT),1,".","");
	}

	// update from Cumulus realtime.txt
	if($type=="cumulus"){
		$realtime = file_get_contents($path);
		$realtimeData = explode(" ",$realtime);
		// damn Cumulus is of course not standardized... get units
		$dataTempUnits = $realtimeData[14];
		$current['T'] = number_format(convertT($realtimeData[2]),1,".","");
		$current['D'] = number_format(convertT($realtimeData[4]),1,".","");
		$current['A'] = number_format(convertT($realtimeData[54]),1,".","");
	}

	if($type=="mb"){
		// set units for mb
		$dataTempUnits = "C";
		$mbLive = file_get_contents($path);
		$mbLiveData = explode(";",$mbLive);
		$current['T'] = number_format(convertT($mbLiveData[0]),1,".","");
		$current['D'] = number_format(convertT($mbLiveData[7]),1,".","");
		$current['A'] = number_format(convertT($mbLiveData[13]),1,".","");
	}

	if($type=="weatherCat"){
		$realtimeMT = explode("###",file_get_contents($path));
		for($a=0;$a<count($realtimeMT);$a++){
			$splitRow = explode("|",$realtimeMT[$a]);
			$key = $splitRow[0];
			$keyValue = str_replace(",",".",$splitRow[1]);
			$cleanDataArr[trim($key)] = trim($keyValue);
		}
		$currentT = $cleanDataArr['T'];
		$currentH = $cleanDataArr['H'];
		$currentW = $cleanDataArr['W'];

		if (strpos($cleanDataArr['unitsT'], 'C') !== false) {
			$fileTempUnits = "C";
			$currentTC = $currentT;
		}
		else if (strpos($cleanDataArr['unitsT'], 'F') !== false) {
			$fileTempUnits = "F";
			$currentTC = ($currentT - 32)/1.8;
		}
		else{
			$fileTempUnits = "C";
		}
		$fileWindUnits = strtolower($cleanDataArr['unitsW']);
		if($displayTempUnits=="F" && $fileTempUnits=="C"){
			$currentT = round(($currentT * 1.8) + 32,1);
		}
		if($displayTempUnits=="C" && $fileTempUnits=="F"){
			$currentT = round(($currentT -32) / 1.8,1);
		}

		if($fileWindUnits=="km/h"){
			$currentWMS = $currentW/3.6;
		}
		if($fileWindUnits=="m/s"){
			$currentWMS = $currentW;
		}
		if($fileWindUnits=="knots"){
			$currentWMS = $currentW* 0.514444;
		}
		if($fileWindUnits=="mph"){
			$currentWMS = $currentW* 0.44704;
		}

		if($displayWindUnits=="kmh" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 1,1);

		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 3.6,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.852,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1.60934,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="km/h"){
			$currentW = round($currentW / 3.6,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 1,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 0.514444,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 0.44704,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 0.621371,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 2.23694,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.15078,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1,1);
		}

		$current['T'] = number_format($currentT,1,".","");
		$current['H'] = number_format($currentH,1,".","");
		$current['W'] = number_format($currentW,1,".","");
		$currentA = apparentWeatherCat($currentTC, $currentH, $currentWMS);
		$currentD = dewpointWeatherCat($currentTC, $currentH);
		if($displayTempUnits=="F"){
			$currentA = $currentA*1.8 + 32;
			$currentD = $currentD*1.8 + 32;
		}
		$current['D'] = number_format($currentD,1,".","");
		$current['A'] = number_format($currentA,1,".","");
	}

	// get color by interval
	$gaugeInterval = $thermometerMaximum - $thermometerMinimum;
	$currentOffset['T'] = ($current['T']-$thermometerMinimum)/$gaugeInterval;
	$currentOffset['A'] = ($current['A']-$thermometerMinimum)/$gaugeInterval;
	$currentOffset['D'] = ($current['D']-$thermometerMinimum)/$gaugeInterval;

	$current['color']['T'] = getGaugeColor($currentOffset['T']);
	$current['color']['A'] = getGaugeColor($currentOffset['A']);
	$current['color']['D'] = getGaugeColor($currentOffset['D']);

	$current = json_encode($current, JSON_NUMERIC_CHECK);
	echo $current;

	function getGaugeColor($offset){
		if($offset<=0.1){
			return array("#0C00F5","#3C33F7");
		}
		else if($offset>0.1 && $offset<=0.2){
			return array("#3C33F7","#6D66F9");
		}
		else if($offset>0.2 && $offset<=0.3){
			return array("#6D66F9","#9D99FB");
		}
		else if($offset>0.3 && $offset<=0.4){
			return array("#9D99FB","#CECCFD");
		}
		else if($offset>0.4 && $offset<=0.5){
			return array("#CECCFD","#edecfc");
		}
		else if($offset>0.5 && $offset<=0.6){
			return array("#E6BFBF","#edd8d8");
		}
		else if($offset>0.6 && $offset<=0.7){
			return array("#CE7F7F","#E6BFBF");
		}
		else if($offset>0.7 && $offset<=0.8){
			return array("#B63F3F","#CE7F7F");
		}
		else if($offset>0.8 && $offset<=0.9){
			return array("#9E0000","#B63F3F");
		}
		else{
			return array("#620000","#9E0000");
		}
	}

	function apparent($T,$H,$W){
		$T = ($T-32)/1.8;
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		$A = ($A*1.8)+32;
		return $A;
	}
	function apparentWeatherCat($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function apparentWD($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function dewpointWeatherCat($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}
	function dewpoint($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}


?>
