<?php

	# 		Thermometer
	# 		Namespace:		thermometer
	#		Meteotemplate Block

	# 		v2.0 - Mar 13, 2017
	# 			- added Meteotemplate API support
	# 		v3.0 - Mar 21, 2017
	# 			- added daily min/max


	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];

	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");

	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);

	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}
	$type = $sourceType;
	$path = $filePath;

	if($displayTempUnits=="C"){
		$thermometerMinimum = $thermometerMinimumC;
		$thermometerMaximum = $thermometerMaximumC;
	}
	if($displayTempUnits=="F"){
		$thermometerMinimum = $thermometerMinimumF;
		$thermometerMaximum = $thermometerMaximumF;
	}

	// if units set to C, use interval 10, if F, use 20
	if($displayTempUnits=="C"){
		for($i=$thermometerMinimum;$i<=$thermometerMaximum;$i=$i+10){
			$thermoMaxTicks[] = $i;
		}
	}
	if($displayTempUnits=="F"){
		for($i=$thermometerMinimum;$i<=$thermometerMaximum;$i=$i+20){
			$thermoMaxTicks[] = $i;
		}
	}

	$gaugeInterval = $thermometerMaximum - $thermometerMinimum;

	// use API
	if($type=="api"){
		$apiData = file_get_contents("../../../meteotemplateLive.txt");
		$apiData = json_decode($apiData,true);
		$current['T'] = number_format(convertor($apiData['T'],"C",$displayTempUnits),1,".","");
		$current['D'] = number_format(convertor($apiData['D'],"C",$displayTempUnits),1,".","");
		$current['A'] = number_format(convertor($apiData['A'],"C",$displayTempUnits),1,".","");
	}

	// update from database
	if($type=="db"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,A,D
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
		}
	}

	// update from database from WL
	if($type=="wl"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,A,D
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
		}
	}

	// update from clientraw
	if($type=="wd"){
		// set units for wd
		$dataTempUnits = "C";
		$clientraw = file_get_contents($path);
		$clientrawData = explode(" ",$clientraw);

		$current['T'] = number_format(convertT($clientrawData[4]),1,".","");
		$current['D'] = number_format(convertT($clientrawData[72]),1,".","");
		$apparentT = apparentWD($clientrawData[4],$clientrawData[5],($clientrawData[1]*0.514444));
		$current['A'] = number_format(convertT($apparentT),1,".","");
	}

	// update from Cumulus realtime.txt
	if($type=="cumulus"){
		$realtime = file_get_contents($path);
		$realtimeData = explode(" ",$realtime);
		// damn Cumulus is of course not standardized... get units
		$dataTempUnits = $realtimeData[14];
		$current['T'] = number_format(convertT($realtimeData[2]),1,".","");
		$current['D'] = number_format(convertT($realtimeData[4]),1,".","");
		$current['A'] = number_format(convertT($realtimeData[54]),1,".","");
	}

	if($type=="mb"){
		// set units for mb
		$dataTempUnits = "C";
		$mbLive = file_get_contents($path);
		$mbLiveData = explode(";",$mbLive);
		$current['T'] = number_format(convertT($mbLiveData[0]),1,".","");
		$current['D'] = number_format(convertT($mbLiveData[7]),1,".","");
		$current['A'] = number_format(convertT($mbLiveData[13]),1,".","");
	}

	if($type=="weatherCat"){
		$realtimeMT = explode("###",file_get_contents($path));
		for($a=0;$a<count($realtimeMT);$a++){
			$splitRow = explode("|",$realtimeMT[$a]);
			$key = $splitRow[0];
			$keyValue = str_replace(",",".",$splitRow[1]);
			$cleanDataArr[trim($key)] = trim($keyValue);
		}
		$currentT = $cleanDataArr['T'];
		$currentH = $cleanDataArr['H'];
		$currentW = $cleanDataArr['W'];

		if (strpos($cleanDataArr['unitsT'], 'C') !== false) {
			$fileTempUnits = "C";
			$currentTC = $currentT;
		}
		else if (strpos($cleanDataArr['unitsT'], 'F') !== false) {
			$fileTempUnits = "F";
			$currentTC = ($currentT - 32)/1.8;
		}
		else{
			$fileTempUnits = "C";
		}
		$fileWindUnits = strtolower($cleanDataArr['unitsW']);
		if($displayTempUnits=="F" && $fileTempUnits=="C"){
			$currentT = round(($currentT * 1.8) + 32,1);
		}
		if($displayTempUnits=="C" && $fileTempUnits=="F"){
			$currentT = round(($currentT -32) / 1.8,1);
		}

		if($fileWindUnits=="km/h"){
			$currentWMS = $currentW/3.6;
		}
		if($fileWindUnits=="m/s"){
			$currentWMS = $currentW;
		}
		if($fileWindUnits=="knots"){
			$currentWMS = $currentW* 0.514444;
		}
		if($fileWindUnits=="mph"){
			$currentWMS = $currentW* 0.44704;
		}

		if($displayWindUnits=="kmh" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 1,1);

		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 3.6,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.852,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1.60934,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="km/h"){
			$currentW = round($currentW / 3.6,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 1,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 0.514444,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 0.44704,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 0.621371,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 2.23694,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.15078,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1,1);
		}

		$current['T'] = number_format($currentT,1,".","");
		$current['H'] = number_format($currentH,1,".","");
		$current['W'] = number_format($currentW,1,".","");
		$currentA = apparentWeatherCat($currentTC, $currentH, $currentWMS);
		$currentD = dewpointWeatherCat($currentTC, $currentH);
		if($displayTempUnits=="F"){
			$currentA = $currentA*1.8 + 32;
			$currentD = $currentD*1.8 + 32;
		}
		$current['D'] = number_format($currentD,1,".","");
		$current['A'] = number_format($currentA,1,".","");
	}

	$result = mysqli_query($con,"
		SELECT DateTime,max(Tmax), min(Tmin), max(A), min(A), max(D), min(D)
		FROM alldata
		WHERE DATE(DateTime) = CURDATE()
		"
	);
	while($row = mysqli_fetch_array($result)){
		$todayMaxT = number_format(convertT($row['max(Tmax)']),1,".","");
		$todayMaxA = number_format(convertT($row['max(A)']),1,".","");
		$todayMaxD = number_format(convertT($row['max(D)']),1,".","");
		$todayMinT = number_format(convertT($row['min(Tmin)']),1,".","");
		$todayMinA = number_format(convertT($row['min(A)']),1,".","");
		$todayMinD = number_format(convertT($row['min(D)']),1,".","");
	}

	// check if current values do not exceed db values
	if($todayMaxT<$current['T']){
		$current['maxT'] = $current['T'];
	}
	else{
		$current['maxT'] = $todayMaxT;
	}
	if($todayMinT>$current['T']){
		$current['minT'] = $current['T'];
	}
	else{
		$current['minT'] = $todayMinT;
	}

	if($todayMaxA<$current['A']){
		$current['maxA'] = $current['A'];
	}
	else{
		$current['maxA'] = $todayMaxA;
	}
	if($todayMinA>$current['A']){
		$current['minA'] = $current['A'];
	}
	else{
		$current['minA'] = $todayMinA;
	}

	if($todayMaxD<$current['D']){
		$current['maxD'] = $current['D'];
	}
	else{
		$current['maxD'] = $todayMaxD;
	}
	if($todayMinD>$current['D']){
		$current['minD'] = $current['D'];
	}
	else{
		$current['minD'] = $todayMinD;
	}

	// get color by interval
	$gaugeInterval = $thermometerMaximum - $thermometerMinimum;
	$currentOffset['T'] = ($current['T']-$thermometerMinimum)/$gaugeInterval;

	$current['color']['T'] = getGaugeColor($currentOffset['T']);

	$themeBasedColor = $theme=="dark" ? $color_schemes[$design2]['200'] : $color_schemes[$design]['800'];

	function getGaugeColor($offset){
		if($offset<=0.1){
			return array("#0C00F5","#3C33F7");
		}
		else if($offset>0.1 && $offset<=0.2){
			return array("#3C33F7","#6D66F9");
		}
		else if($offset>0.2 && $offset<=0.3){
			return array("#6D66F9","#9D99FB");
		}
		else if($offset>0.3 && $offset<=0.4){
			return array("#9D99FB","#CECCFD");
		}
		else if($offset>0.4 && $offset<=0.5){
			return array("#CECCFD","#edecfc");
		}
		else if($offset>0.5 && $offset<=0.6){
			return array("#E6BFBF","#edd8d8");
		}
		else if($offset>0.6 && $offset<=0.7){
			return array("#CE7F7F","#E6BFBF");
		}
		else if($offset>0.7 && $offset<=0.8){
			return array("#B63F3F","#CE7F7F");
		}
		else if($offset>0.8 && $offset<=0.9){
			return array("#9E0000","#B63F3F");
		}
		else{
			return array("#620000","#9E0000");
		}
	}

	function apparent($T,$H,$W){
		$T = ($T-32)/1.8;
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		$A = ($A*1.8)+32;
		return $A;
	}
	function apparentWeatherCat($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function apparentWD($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function dewpointWeatherCat($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}
	function dewpoint($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}
?>
	<script src="homepage/blocks/thermometer/gauge.js"></script>
	<style>
		.thermometerSwitch{
			font-size:1.8em;
			opacity: 0.7;
			cursor: pointer;
			padding-top: 10px;
			padding-left: 2px;
			padding-right: 2px;
		}
		.thermometerSwitch:hover{
			opacity: 1;
		}
		.thermometerSwitchActive{
			opacity: 1;
			font-size:1.8em;
			cursor: normal;
			padding-top: 10px;
			padding-left: 2px;
			padding-right: 2px;
		}
	</style>
	<div style="width:98%;margin: 0 auto;text-align:center">
		<table style="margin: 0 auto">
			<tr>
				<td style="width:33%">
					<span class="mticon-temp tooltip thermometerSwitch thermometerSwitchActive" title="<?php echo lang('temperature','c')?>" data-id="T" id="thermometerSwitchT"></span>
				</td>
				<td style="width:33%">
					<span class="mticon-apparent tooltip thermometerSwitch" title="<?php echo lang('apparent temperature','c')?>" data-id="A" id="thermometerSwitchA"></span>
				</td>
				<td style="width:33%">
					<span class="mticon-dewpoint tooltip thermometerSwitch" title="<?php echo lang('dew point','c')?>" data-id="D" id="thermometerSwitchD"></span>
				</td>
			</tr>
		</table>
	</div>
	<?php 
		if($thermometerShowRecords){
	?>
			<div id="thermometerRecordsT" style="width:98%;margin:0 auto;color:white;font-variant:small-caps;color:#<?php echo $themeBasedColor?>" class="thermometerRecords">
				<?php echo lang('today','c')."<br>".$current['maxT']." / ".$current['minT']?>
			</div>
			<div id="thermometerRecordsA" style="width:98%;margin:0 auto;color:white;font-variant:small-caps;display:none;color:#<?php echo $themeBasedColor?>" class="thermometerRecords">
				<?php echo lang('today','c')."<br>".$current['maxA']." / ".$current['minA']?>
			</div>
			<div id="thermometerRecordsD" style="width:98%;margin:0 auto;color:white;font-variant:small-caps;display:none;color:#<?php echo $themeBasedColor?>" class="thermometerRecords">
				<?php echo lang('today','c')."<br>".$current['maxD']." / ".$current['minD']?>
			</div>
	<?php 
		}
	?>
 	<canvas id="thermometerGauge" style="width:98%"></canvas>
	<input type="hidden" id="thermometerT" value="<?php echo $current['T']?>"/>
	<input type="hidden" id="thermometerA" />
	<input type="hidden" id="thermometerD" />
	<input type="hidden" id="thermometerTcolor1" />
	<input type="hidden" id="thermometerAcolor1" />
	<input type="hidden" id="thermometerDcolor1" />
	<input type="hidden" id="thermometerTcolor2" />
	<input type="hidden" id="thermometerAcolor2" />
	<input type="hidden" id="thermometerDcolor2" />
	<input type="hidden" id="thermometerSelected" value="T" />
	<script>
		width = $("#thermometerGauge").width() * 0.98;
		if(width>200){
			width = 200;
		}
		var gaugeThermometer = new LinearGauge({
		    renderTo: 'thermometerGauge',
		    width: width,
		    height: <?php echo $thermoHeight?>,
			minValue: <?php echo $thermometerMinimum?>,
			maxValue: <?php echo $thermometerMaximum?>,
			units: "°<?php echo $displayTempUnits?>",
			title: false,
			exactTicks: false,
			majorTicks: [<?php echo implode(",",$thermoMaxTicks)?>],
			minorTicks: 10,
			strokeTicks: false,
			highlights: [
				{
					from: <?php echo $thermometerMinimum?>,
					to: <?php echo $thermometerMinimum + 0.15*$gaugeInterval?>,
					color: "#002994"
				},
				{
					from: <?php echo $thermometerMinimum + 0.15*$gaugeInterval?>,
					to: <?php echo $thermometerMinimum + 0.3*$gaugeInterval?>,
					color: "#476dd0"
				},
				{
					from: <?php echo $thermometerMinimum + 0.7*$gaugeInterval?>,
					to: <?php echo $thermometerMinimum + 0.85*$gaugeInterval?>,
					color: "#e22424"
				},
				{
					from: <?php echo $thermometerMinimum + 0.85*$gaugeInterval?>,
					to: <?php echo $thermometerMaximum?>,
					color: "#8f0000"
				}
			],
			highlightsWidth: 5,
			barStrokeWidth: 3, // line around thermometer
			barProgress: true,
			animation: true,
			animationDuration: 1000,
			animationRule: "<?php echo $thermoAnimationType?>", // linear,quad,quint,cycle,bounce,elastic,dequad,dequint,decycle,debounce,delastic
			animatedValue: true,
			animateOnInit: true,
			colorPlate: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorMajorTicks: "#<?php echo $themeBasedColor?>",
			colorMinorTicks: "#<?php echo $themeBasedColor?>",
			colorTitle: "#<?php echo $themeBasedColor?>",
			colorUnits: "#<?php echo $themeBasedColor?>",
			colorNumbers: "#<?php echo $themeBasedColor?>",
			colorNeedle: "#<?php echo $theme=="dark" ? "fff" : "000"?>",
			colorNeedleEnd: false,
			colorValueText: "#<?php echo $themeBasedColor?>",
			colorValueTextShadow: false,
			colorBorderShadow: false,
			colorBorderOuter: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorBorderOuterEnd: false,
			colorBorderMiddle: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorBorderMiddleEnd: false,
			colorBorderInner: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorBorderInnerEnd: false,
			colorValueBoxRect: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorValueBoxRectEnd: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorValueBoxBackground: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorValueBoxShadow: "#<?php echo $theme=="dark" ? $color_schemes[$design]['900'] : $color_schemes[$design]['300']?>",
			colorBarStroke: "#<?php echo $theme=="dark" ? $color_schemes[$design2]['900'] : $color_schemes[$design2]['100']?>",
			colorBar: "#<?php echo $theme=="dark" ? $color_schemes[$design2]['700'] : $color_schemes[$design2]['300']?>",
			colorBarProgress: "<?php echo $current['color']['T'][1]?>",
			needleShadow: true,
			needleType: "arrow", // line, arrow
			needleStart: 5,
			needleEnd: 20,
			needleWidth: 5,
			valueBox: true,
			valueInt: 2,
			valueDec: 1,
			fontNumbers: 'Helvetica',
			fontUnits: 'Verdana',
			fontValue: 'Verdana',
			fontNumbersSize: 18,
			fontUnitsSize: 17,
			fontValueSize: 20,
			fontNumbersWeight: '300',
			// fontValueWeight: '300',
			// barBeginCircle: 0,
			colorBarProgressEnd: "<?php echo $current['color']['T'][0]?>",
			tickSide: "<?php echo $thermoScaleSide?>", // left, right, both
			needleSide: "<?php echo $thermoScaleSide?>", // left, right, both
			numberSide: "<?php echo $thermoScaleSide?>", // left, right, both
			ticksWidth: 8,
			ticksWidthMinor: 4,
			ticksPadding: 3,
		});
		gaugeThermometer.draw();
		gaugeThermometer.value = <?php echo $current['T']?>;
		thermoUpdater();
		setInterval(function(){ thermoUpdater(); }, (<?php echo $thermometerUpdateInterval?>*1000));
		function thermoUpdater(){
			<?php 
				if($thermometerShowRecords){
			?>
					origMaxT = <?php echo number_format($current['maxT'],1,".","")?>;
					origMaxA = <?php echo number_format($current['maxA'],1,".","")?>;
					origMaxD = <?php echo number_format($current['maxD'],1,".","")?>;
					origMinT = <?php echo number_format($current['minT'],1,".","")?>;
					origMinA = <?php echo number_format($current['minA'],1,".","")?>;
					origMinD = <?php echo number_format($current['minD'],1,".","")?>;
			<?php 
				}
			?>
			$.ajax({
				url : "homepage/blocks/thermometer/thermoUpdater.php",
				dataType : 'json',
				success : function (json) {
					$("#thermometerT").val(json['T']);
					$("#thermometerA").val(json['A']);
					$("#thermometerD").val(json['D']);
					<?php 
						if($thermometerShowRecords){
					?>
							if(origMaxT<json['T']){
								origMaxT = json['T'];
							}
							if(origMinT>json['T']){
								origMinT = json['T'];
							}
							if(origMaxA<json['A']){
								origMaxA = json['A'];
							}
							if(origMinA>json['A']){
								origMinA = json['A'];
							}
							if(origMaxD<json['D']){
								origMaxD = json['D'];
							}
							if(origMinD>json['D']){
								origMinD = json['D'];
							}
					<?php 
						}
					?>
					$("#thermometerTcolor1").val(json['color']['T'][0]);
					$("#thermometerAcolor1").val(json['color']['A'][0]);
					$("#thermometerDcolor1").val(json['color']['D'][0]);
					$("#thermometerTcolor2").val(json['color']['T'][1]);
					$("#thermometerAcolor2").val(json['color']['A'][1]);
					$("#thermometerDcolor2").val(json['color']['D'][1]);
					$("#thermometerRecordsT").html("<?php echo lang('today','c')?><br>"+ origMaxT + " / " + origMinT);
					$("#thermometerRecordsA").html("<?php echo lang('today','c')?><br>"+ origMaxA + " / " + origMinA);
					$("#thermometerRecordsD").html("<?php echo lang('today','c')?><br>"+ origMaxD + " / " + origMinD);
					currentlySelectedThermo = $("#thermometerSelected").val();
					if(json[currentlySelectedThermo]<10 && json[currentlySelectedThermo]>-10){
						gaugeThermometer.update({
						   	valueInt: 1,
						});
					}
					else{
						gaugeThermometer.update({
						   	valueInt: 2,
						});
					}
					gaugeThermometer.update({
						colorBarProgress: json['color'][currentlySelectedThermo][0],
						colorBar: json['color'][currentlySelectedThermo][1]
					});
					gaugeThermometer.value = eval($("#thermometer" + currentlySelectedThermo).val());
				},
			});
		}
		$(".thermometerSwitch").click(function(){
			thermoUpdater();
			currentlySelected = $("#thermometerSelected").val();
			$("#thermometerSwitch"+currentlySelected).removeClass("thermometerSwitchActive");
			$("#thermometerSwitch"+currentlySelected).addClass("thermometerSwitch");
			$(this).removeClass("thermometerSwitch");
			$(this).addClass("thermometerSwitchActive");
			switchType = $(this).attr("data-id");
			switchValue = eval($("#thermometer"+switchType).val());
			if(switchValue<10 && switchValue-10){
				gaugeThermometer.update({
					valueInt: 1,
				});
			}
			else{
				gaugeThermometer.update({
					valueInt: 2,
				});
			}
			gaugeThermometer.update({
				colorBarProgress: $("#thermometer" + switchType + "color1").val(),
				colorBar: $("#thermometer" + switchType + "color2").val(),
			});
			gaugeThermometer.value = switchValue;
			$("#thermometerSelected").val(switchType);
			<?php 
				if($thermometerShowRecords){
			?>
					$(".thermometerRecords").hide();
					$("#thermometerRecords"+switchType).show();
			<?php 
				}
			?>
		})
	</script>
